-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onInit()
	electrics.values.speedKN = 0
  electrics.values.asi_kn = 0
end

local function onReset()
	onInit()
end

local function updateGFX(dt)
  local curKnots = obj:getVelocity():length() * 1.94384
  electrics.values.speedKN = curKnots
  
  if curKnots >= 800 then return end --over the limit pal
  
  if curKnots >= 400 then
    electrics.values.asi_kn = (((curKnots - 400) / 100) * 0.07619166) + (0.684991666)
  elseif curKnots >= 300 then
    electrics.values.asi_kn = (((curKnots - 300) / 100) * 0.162791666) + (0.522775)
  elseif curKnots >= 100 then
    electrics.values.asi_kn = (((curKnots - 100) / 100) * 0.198) + 0.125744
  else
    electrics.values.asi_kn = (curKnots / 100) * 0.125744
  end
end

-- public interface
M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX

return M