-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local lastGearState = 0
local inTime = 7
local outTime = 2.5
local currentTimer = inTime
local maxTime = inTime
local doTimer = false
local currentTimerDir = 1

local function onInit()
	electrics.values['gearTimeFactor'] = 1
end

local function onReset()
	onInit()
end

local function updateGFX(dt)
  local electric = electrics.values.landingGear
  if electric ~= lastGearState then
    lastGearState = electric
    if electric == 0 then currentTimerDir = 1 else currentTimerDir = -1 end
    
    if currentTimerDir == -1 then
      maxTime = inTime
      currentTimer = inTime
    else
      currentTimer = (currentTimer / maxTime) * outTime
      maxTime = outTime
      
    end
    
    doTimer = true
  end
  
  if doTimer then
    currentTimer = currentTimer + (dt * currentTimerDir)
    
    if currentTimer > maxTime then 
      currentTimer = maxTime 
      doTimer = false
    elseif currentTimer < 0 then
      currentTimer = 0
      doTimer = false
    end
    
    electrics.values['gearTimeFactor'] = currentTimer / maxTime
  end
end

-- public interface
M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX

return M